Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_foreach.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_foreach.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_foreach.php	(revision )
@@ -14,7 +14,7 @@
  * @package    Smarty
  * @subpackage Compiler
  */
-class Smarty_Internal_Compile_Foreach extends Smarty_Internal_CompileBase
+class Smarty_Internal_Compile_Foreach extends Smarty_Internal_Compile_Private_ForeachSection
 {
     /**
      * Attribute definition: Overwrites base class.
@@ -23,6 +23,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $required_attributes = array('from', 'item');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -30,6 +31,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $optional_attributes = array('name', 'key');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -39,128 +41,231 @@
     public $shorttag_order = array('from', 'item', 'key', 'name');
 
     /**
+     * counter
+     *
+     * @var int
+     */
+    public $counter = 0;
+
+    /**
+     * Name of this tag
+     *
+     * @var string
+     */
+    public $tagName = 'foreach';
+
+    /**
+     * Valid properties of $smarty.foreach.name.xxx variable
+     *
+     * @var array
+     */
+    public $nameProperties = array('first', 'last', 'index', 'iteration', 'show', 'total');
+
+    /**
+     * Valid properties of $item@xxx variable
+     *
+     * @var array
+     */
+    public $itemProperties = array('first', 'last', 'index', 'iteration', 'show', 'total', 'key');
+
+    /**
+     * Flag if tag had name attribute
+     *
+     * @var bool
+     */
+    public $isNamed = false;
+
+    /**
      * Compiles code for the {foreach} tag
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                $parameter array with compilation parameter
      *
      * @return string compiled code
+     * @throws \SmartyCompilerException
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
+        $compiler->loopNesting ++;
+        // init
+        $this->isNamed = false;
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
-
         $from = $_attr['from'];
-        $item = $_attr['item'];
-        if (!strncmp("\$_smarty_tpl->tpl_vars[$item]", $from, strlen($item) + 24)) {
-            $compiler->trigger_template_error("item variable {$item} may not be the same variable as at 'from'", $compiler->lex->taglineno);
+        $item = $compiler->getId($_attr['item']);
+        if ($item === false) {
+            $item = $compiler->getVariableName($_attr['item']);
         }
-
+        $attributes = array('item' => $item);
         if (isset($_attr['key'])) {
-            $key = $_attr['key'];
-        } else {
-            $key = null;
+            $key = $compiler->getId($_attr['key']);
+            if ($key === false) {
+                $key = $compiler->getVariableName($_attr['key']);
-        }
+            }
+            $attributes['key'] = $key;
+        }
+        if (isset($_attr['name'])) {
+            $this->isNamed = true;
+            $attributes['name'] = $compiler->getId($_attr['name']);
+        }
+        foreach ($attributes as $a => $v) {
+            if ($v === false) {
+                $compiler->trigger_template_error("'{$a}' attribute/variable has illegal value", null, true);
+            }
+        }
+        $fromName = $compiler->getVariableName($_attr['from']);
+        if ($fromName) {
+            foreach (array('item', 'key') as $a) {
+                if (isset($attributes[$a]) && $attributes[$a] == $fromName) {
+                    $compiler->trigger_template_error("'{$a}' and 'from' may not have same variable name '{$fromName}'",
+                                                      null, true);
+                }
+            }
+        }
 
-        $this->openTag($compiler, 'foreach', array('foreach', $compiler->nocache, $item, $key));
-        // maybe nocache because of nocache variables
-        $compiler->nocache = $compiler->nocache | $compiler->tag_nocache;
+        $itemVar = "\$_smarty_tpl->tpl_vars['{$item}']";
+        $local = '$__foreach_' . (isset($attributes['name']) ? $attributes['name'] : $attributes['item']) . '_' .
+            $this->counter ++ . '_';
+        $needIteration = false;
+        // search for used tag attributes
+        $itemAttr = array();
+        $namedAttr = array();
+        $this->scanForProperties($attributes, $compiler);
+        if (!empty($this->matchResults['item'])) {
+            $itemAttr = $this->matchResults['item'];
+        }
+        if (!empty($this->matchResults['named'])) {
+            $namedAttr = $this->matchResults['named'];
+        }
+        if (isset($itemAttr['last'])) {
+            $needIteration = true;
+        }
+        if (isset($namedAttr['last'])) {
+            $needIteration = true;
+        }
 
-        if (isset($_attr['name'])) {
-            $name = $_attr['name'];
-            $has_name = true;
-            $SmartyVarName = '$smarty.foreach.' . trim($name, '\'"') . '.';
-        } else {
-            $name = null;
-            $has_name = false;
+        $keyTerm = '';
+        if (isset($itemAttr['key'])) {
+            $keyTerm = "{$itemVar}->key => ";
+        } elseif (isset($attributes['key'])) {
+            $keyTerm = "\$_smarty_tpl->tpl_vars['{$key}']->value => ";
         }
-        $ItemVarName = '$' . trim($item, '\'"') . '@';
-        // evaluates which Smarty variables and properties have to be computed
-        if ($has_name) {
-            $usesSmartyFirst = strpos($compiler->lex->data, $SmartyVarName . 'first') !== false;
-            $usesSmartyLast = strpos($compiler->lex->data, $SmartyVarName . 'last') !== false;
-            $usesSmartyIndex = strpos($compiler->lex->data, $SmartyVarName . 'index') !== false;
-            $usesSmartyIteration = strpos($compiler->lex->data, $SmartyVarName . 'iteration') !== false;
-            $usesSmartyShow = strpos($compiler->lex->data, $SmartyVarName . 'show') !== false;
-            $usesSmartyTotal = strpos($compiler->lex->data, $SmartyVarName . 'total') !== false;
-        } else {
-            $usesSmartyFirst = false;
-            $usesSmartyLast = false;
-            $usesSmartyTotal = false;
-            $usesSmartyShow = false;
+
+        $saveVars = array();
+        $restoreVars = array();
+        if ($this->isNamed) {
+            $foreachVar = "\$_smarty_tpl->tpl_vars['__smarty_foreach_{$attributes['name']}']";
+            if (!empty($namedAttr)) {
+                $saveVars['saved'] = "isset({$foreachVar}) ? {$foreachVar} : false;";
+                $restoreVars[] = "if ({$local}saved) {\n{$foreachVar} = {$local}saved;\n}\n";
-        }
+            }
+        }
+        foreach (array('item', 'key') as $a) {
+            if (isset($attributes[$a])) {
+                $saveVars['saved_' . $a] =
+                    "isset(\$_smarty_tpl->tpl_vars['{$attributes[$a]}']) ? \$_smarty_tpl->tpl_vars['{$attributes[$a]}'] : false;";
+                $restoreVars[] =
+                    "if ({$local}saved_{$a}) {\n\$_smarty_tpl->tpl_vars['{$attributes[$a]}'] = {$local}saved_{$a};\n}\n";
+            }
+        }
+        $this->openTag($compiler, 'foreach',
+                       array('foreach', $compiler->nocache, $local, $restoreVars, $itemVar, true));
+        // maybe nocache because of nocache variables
+        $compiler->nocache = $compiler->nocache | $compiler->tag_nocache;
 
-        $usesPropFirst = $usesSmartyFirst || strpos($compiler->lex->data, $ItemVarName . 'first') !== false;
-        $usesPropLast = $usesSmartyLast || strpos($compiler->lex->data, $ItemVarName . 'last') !== false;
-        $usesPropIndex = $usesPropFirst || strpos($compiler->lex->data, $ItemVarName . 'index') !== false;
-        $usesPropIteration = $usesPropLast || strpos($compiler->lex->data, $ItemVarName . 'iteration') !== false;
-        $usesPropShow = strpos($compiler->lex->data, $ItemVarName . 'show') !== false;
-        $usesPropTotal = $usesSmartyTotal || $usesSmartyShow || $usesPropShow || $usesPropLast || strpos($compiler->lex->data, $ItemVarName . 'total') !== false;
         // generate output code
-        $output = "<?php ";
-        $output .= " \$_smarty_tpl->tpl_vars[$item] = new Smarty_Variable; \$_smarty_tpl->tpl_vars[$item]->_loop = false;\n";
-        if ($key != null) {
-            $output .= " \$_smarty_tpl->tpl_vars[$key] = new Smarty_Variable;\n";
+        $output = "<?php\n";
+        $output .= "\$_from = $from;\n";
+        $output .= "if (!is_array(\$_from) && !is_object(\$_from)) {\n";
+        $output .= "settype(\$_from, 'array');\n";
+        $output .= "}\n";
+        foreach ($saveVars as $k => $code) {
+            $output .= "{$local}{$k} = {$code}\n";
         }
-        $output .= " \$_from = $from; if (!is_array(\$_from) && !is_object(\$_from)) { settype(\$_from, 'array');}\n";
-        if ($usesPropTotal) {
-            $output .= " \$_smarty_tpl->tpl_vars[$item]->total= \$_smarty_tpl->_count(\$_from);\n";
+        if (isset($itemAttr['show']) || isset($itemAttr['total']) || isset($namedAttr['total']) || isset($namedAttr['show']) || isset($itemAttr['last']) || isset($namedAttr['last'])) {
+            $output .= "{$local}total = \$_smarty_tpl->smarty->ext->_foreach->count(\$_from);\n";
         }
-        if ($usesPropIteration) {
-            $output .= " \$_smarty_tpl->tpl_vars[$item]->iteration=0;\n";
+        $output .= "{$itemVar} = new Smarty_Variable();\n";
+        if (isset($itemAttr['show'])) {
+            $output .= "{$itemVar}->show = ({$local}total > 0);\n";
         }
-        if ($usesPropIndex) {
-            $output .= " \$_smarty_tpl->tpl_vars[$item]->index=-1;\n";
+        if (isset($itemAttr['total'])) {
+            $output .= "{$itemVar}->total= {$local}total;\n";
         }
-        if ($usesPropShow) {
-            $output .= " \$_smarty_tpl->tpl_vars[$item]->show = (\$_smarty_tpl->tpl_vars[$item]->total > 0);\n";
+        if ($this->isNamed) {
+            $prop = array();
+            if (isset($namedAttr['total'])) {
+                $prop['total'] = "'total' => {$local}total";
-        }
+            }
-        if ($has_name) {
-            if ($usesSmartyTotal) {
-                $output .= " \$_smarty_tpl->tpl_vars['smarty']->value['foreach'][$name]['total'] = \$_smarty_tpl->tpl_vars[$item]->total;\n";
+            if (isset($namedAttr['iteration'])) {
+                $prop['iteration'] = "'iteration' => 0";
             }
-            if ($usesSmartyIteration) {
-                $output .= " \$_smarty_tpl->tpl_vars['smarty']->value['foreach'][$name]['iteration']=0;\n";
+            if (isset($namedAttr['index'])) {
+                $prop['index'] = "'index' => -1";
             }
-            if ($usesSmartyIndex) {
-                $output .= " \$_smarty_tpl->tpl_vars['smarty']->value['foreach'][$name]['index']=-1;\n";
+            if (isset($namedAttr['show'])) {
+                $prop['show'] = "'show' => ({$local}total > 0)";
             }
-            if ($usesSmartyShow) {
-                $output .= " \$_smarty_tpl->tpl_vars['smarty']->value['foreach'][$name]['show']=(\$_smarty_tpl->tpl_vars[$item]->total > 0);\n";
+            if (!empty($namedAttr)) {
+                $_vars = 'array(' . join(', ', $prop) . ')';
+                $output .= "{$foreachVar} = new Smarty_Variable({$_vars});\n";
             }
         }
-        $output .= "foreach (\$_from as \$_smarty_tpl->tpl_vars[$item]->key => \$_smarty_tpl->tpl_vars[$item]->value) {\n\$_smarty_tpl->tpl_vars[$item]->_loop = true;\n";
-        if ($key != null) {
-            $output .= " \$_smarty_tpl->tpl_vars[$key]->value = \$_smarty_tpl->tpl_vars[$item]->key;\n";
+        if (isset($attributes['key'])) {
+            $output .= "\$_smarty_tpl->tpl_vars['{$key}'] = new Smarty_Variable();\n";
         }
-        if ($usesPropIteration) {
-            $output .= " \$_smarty_tpl->tpl_vars[$item]->iteration++;\n";
+        if (isset($namedAttr['first']) || isset($itemAttr['first'])) {
+            $output .= "{$local}first = true;\n";
         }
-        if ($usesPropIndex) {
-            $output .= " \$_smarty_tpl->tpl_vars[$item]->index++;\n";
+        if (isset($itemAttr['iteration'])) {
+            $output .= "{$itemVar}->iteration=0;\n";
         }
-        if ($usesPropFirst) {
-            $output .= " \$_smarty_tpl->tpl_vars[$item]->first = \$_smarty_tpl->tpl_vars[$item]->index === 0;\n";
+        if (isset($itemAttr['index'])) {
+            $output .= "{$itemVar}->index=-1;\n";
         }
-        if ($usesPropLast) {
-            $output .= " \$_smarty_tpl->tpl_vars[$item]->last = \$_smarty_tpl->tpl_vars[$item]->iteration === \$_smarty_tpl->tpl_vars[$item]->total;\n";
+        if ($needIteration) {
+            $output .= "{$local}iteration=0;\n";
         }
-        if ($has_name) {
-            if ($usesSmartyFirst) {
-                $output .= " \$_smarty_tpl->tpl_vars['smarty']->value['foreach'][$name]['first'] = \$_smarty_tpl->tpl_vars[$item]->first;\n";
+        $output .= "{$itemVar}->_loop = false;\n";
+        $output .= "foreach (\$_from as {$keyTerm}{$itemVar}->value) {\n";
+        $output .= "{$itemVar}->_loop = true;\n";
+        if (isset($attributes['key']) && isset($itemAttr['key'])) {
+            $output .= "\$_smarty_tpl->tpl_vars['{$key}']->value = {$itemVar}->key;\n";
-            }
+        }
-            if ($usesSmartyIteration) {
-                $output .= " \$_smarty_tpl->tpl_vars['smarty']->value['foreach'][$name]['iteration']++;\n";
+        if (isset($itemAttr['iteration'])) {
+            $output .= "{$itemVar}->iteration++;\n";
-            }
+        }
-            if ($usesSmartyIndex) {
-                $output .= " \$_smarty_tpl->tpl_vars['smarty']->value['foreach'][$name]['index']++;\n";
+        if (isset($itemAttr['index'])) {
+            $output .= "{$itemVar}->index++;\n";
-            }
+        }
-            if ($usesSmartyLast) {
-                $output .= " \$_smarty_tpl->tpl_vars['smarty']->value['foreach'][$name]['last'] = \$_smarty_tpl->tpl_vars[$item]->last;\n";
+        if ($needIteration) {
+            $output .= "{$local}iteration++;\n";
-            }
+        }
+        if (isset($itemAttr['first'])) {
+            $output .= "{$itemVar}->first = {$local}first;\n";
         }
+        if (isset($itemAttr['last'])) {
+            $output .= "{$itemVar}->last = {$local}iteration == {$local}total;\n";
+        }
+        if ($this->isNamed) {
+            if (isset($namedAttr['iteration'])) {
+                $output .= "{$foreachVar}->value['iteration']++;\n";
+            }
+            if (isset($namedAttr['index'])) {
+                $output .= "{$foreachVar}->value['index']++;\n";
+            }
+            if (isset($namedAttr['first'])) {
+                $output .= "{$foreachVar}->value['first'] = {$local}first;\n";
+            }
+            if (isset($namedAttr['last'])) {
+                $output .= "{$foreachVar}->value['last'] = {$local}iteration == {$local}total;\n";
+            }
+        }
+        if (isset($namedAttr['first']) || isset($itemAttr['first'])) {
+            $output .= "{$local}first = false;\n";
+        }
+        $output .= "{$local}saved_local_item = {$itemVar};\n";
         $output .= "?>";
 
         return $output;
@@ -178,21 +283,24 @@
     /**
      * Compiles code for the {foreachelse} tag
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                $parameter array with compilation parameter
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
 
-        list($openTag, $nocache, $item, $key) = $this->closeTag($compiler, array('foreach'));
-        $this->openTag($compiler, 'foreachelse', array('foreachelse', $nocache, $item, $key));
-
-        return "<?php }\nif (!\$_smarty_tpl->tpl_vars[$item]->_loop) {\n?>";
+        list($openTag, $nocache, $local, $restoreVars, $itemVar, $foo) = $this->closeTag($compiler, array('foreach'));
+        $this->openTag($compiler, 'foreachelse', array('foreachelse', $nocache, $local, $restoreVars, $itemVar, false));
+        $output = "<?php\n";
+        $output .= "{$itemVar} = {$local}saved_local_item;\n";
+        $output .= "}\n";
+        $output .= "if (!{$itemVar}->_loop) {\n?>";
+        return $output;
     }
 }
 
@@ -207,23 +315,33 @@
     /**
      * Compiles code for the {/foreach} tag
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                $parameter array with compilation parameter
      *
      * @return string compiled code
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
-        // check and get attributes
-        $_attr = $this->getAttributes($compiler, $args);
+        $compiler->loopNesting --;
         // must endblock be nocache?
         if ($compiler->nocache) {
             $compiler->tag_nocache = true;
         }
 
-        list($openTag, $compiler->nocache, $item, $key) = $this->closeTag($compiler, array('foreach', 'foreachelse'));
+        list($openTag, $compiler->nocache, $local, $restoreVars, $itemVar, $restore) =
+            $this->closeTag($compiler, array('foreach', 'foreachelse'));
+        $output = "<?php\n";
 
-        return "<?php } ?>";
+        if ($restore) {
+            $output .= "{$itemVar} = {$local}saved_local_item;\n";
+        }
+        $output .= "}\n";
+        foreach ($restoreVars as $restore) {
+            $output .= $restore;
+        }
+        $output .= "?>";
+
+        return $output;
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_call.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_call.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_call.php	(revision )
@@ -23,6 +23,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $required_attributes = array('name');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -30,6 +31,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $shorttag_order = array('name');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -55,13 +57,11 @@
             // output will be stored in a smarty variable instead of being displayed
             $_assign = $_attr['assign'];
         }
+        //$_name = trim($_attr['name'], "'\"");
         $_name = $_attr['name'];
-        if ($compiler->compiles_template_function) {
-            $compiler->called_functions[] = trim($_name, "'\"");
-        }
         unset($_attr['name'], $_attr['assign'], $_attr['nocache']);
         // set flag (compiled code of {function} must be included in cache file
-        if ($compiler->nocache || $compiler->tag_nocache) {
+        if (!$compiler->template->caching || $compiler->nocache || $compiler->tag_nocache) {
             $_nocache = 'true';
         } else {
             $_nocache = 'false';
@@ -74,54 +74,16 @@
                 $_paramsArray[] = "'$_key'=>$_value";
             }
         }
-        if (isset($compiler->template->properties['function'][$_name]['parameter'])) {
-            foreach ($compiler->template->properties['function'][$_name]['parameter'] as $_key => $_value) {
-                if (!isset($_attr[$_key])) {
-                    if (is_int($_key)) {
-                        $_paramsArray[] = "$_key=>$_value";
-                    } else {
-                        $_paramsArray[] = "'$_key'=>$_value";
-                    }
-                }
-            }
-        } elseif (isset($compiler->smarty->template_functions[$_name]['parameter'])) {
-            foreach ($compiler->smarty->template_functions[$_name]['parameter'] as $_key => $_value) {
-                if (!isset($_attr[$_key])) {
-                    if (is_int($_key)) {
-                        $_paramsArray[] = "$_key=>$_value";
-                    } else {
-                        $_paramsArray[] = "'$_key'=>$_value";
-                    }
-                }
-            }
-        }
-        //variable name?
-        if (!(strpos($_name, '$') === false)) {
-            $call_cache = $_name;
-            $call_function = '$tmp = "smarty_template_function_".' . $_name . '; $tmp';
-        } else {
-            $_name = trim($_name, "'\"");
-            $call_cache = "'{$_name}'";
-            $call_function = 'smarty_template_function_' . $_name;
-        }
-
         $_params = 'array(' . implode(",", $_paramsArray) . ')';
-        $_hash = str_replace('-', '_', $compiler->template->properties['nocache_hash']);
+        //$compiler->suppressNocacheProcessing = true;
         // was there an assign attribute
         if (isset($_assign)) {
-            if ($compiler->template->caching) {
-                $_output = "<?php ob_start(); Smarty_Internal_Function_Call_Handler::call ({$call_cache},\$_smarty_tpl,{$_params},'{$_hash}',{$_nocache}); \$_smarty_tpl->assign({$_assign}, ob_get_clean());?>\n";
+            $_output =
+                "<?php ob_start();\n\$_smarty_tpl->smarty->ext->_tplFunction->callTemplateFunction(\$_smarty_tpl, {$_name}, {$_params}, {$_nocache});\n\$_smarty_tpl->assign({$_assign}, ob_get_clean());?>\n";
-            } else {
+        } else {
-                $_output = "<?php ob_start(); {$call_function}(\$_smarty_tpl,{$_params}); \$_smarty_tpl->assign({$_assign}, ob_get_clean());?>\n";
+            $_output =
+                "<?php \$_smarty_tpl->smarty->ext->_tplFunction->callTemplateFunction(\$_smarty_tpl, {$_name}, {$_params}, {$_nocache});?>\n";
-            }
+        }
-        } else {
-            if ($compiler->template->caching) {
-                $_output = "<?php Smarty_Internal_Function_Call_Handler::call ({$call_cache},\$_smarty_tpl,{$_params},'{$_hash}',{$_nocache});?>\n";
-            } else {
-                $_output = "<?php {$call_function}(\$_smarty_tpl,{$_params});?>\n";
-            }
-        }
-
         return $_output;
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_foreach.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_foreach.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_foreach.php	(revision )
@@ -0,0 +1,47 @@
+<?php
+
+/**
+ * Foreach Runtime Methods count
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ *
+ **/
+class Smarty_Internal_Runtime_Foreach
+{
+    /**
+     * [util function] counts an array, arrayAccess/traversable or PDOStatement object
+     *
+     * @param  mixed $value
+     *
+     * @return int   the count for arrays and objects that implement countable, 1 for other objects that don't, and 0
+     *               for empty elements
+     */
+    public function count($value)
+    {
+        if (is_array($value) === true || $value instanceof Countable) {
+            return count($value);
+        } elseif ($value instanceof IteratorAggregate) {
+            // Note: getIterator() returns a Traversable, not an Iterator
+            // thus rewind() and valid() methods may not be present
+            return iterator_count($value->getIterator());
+        } elseif ($value instanceof Iterator) {
+            if ($value instanceof Generator) {
+                return 1;
+            }
+            return iterator_count($value);
+        } elseif ($value instanceof PDOStatement) {
+            return $value->rowCount();
+        } elseif ($value instanceof Traversable) {
+            return iterator_count($value);
+        } elseif ($value instanceof ArrayAccess) {
+            if ($value->offsetExists(0)) {
+                return 1;
+            }
+        } elseif (is_object($value)) {
+            return count($value);
+        }
+        return 0;
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_resource_extends.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_resource_extends.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_resource_extends.php	(revision )
@@ -39,25 +39,24 @@
         $components = explode('|', $source->name);
         $exists = true;
         foreach ($components as $component) {
-            $s = Smarty_Resource::source(null, $source->smarty, $component);
-            if ($s->type == 'php') {
-                throw new SmartyException("Resource type {$s->type} cannot be used with the extends resource type");
+            /* @var \Smarty_Template_Source $_s */
+            $_s = Smarty_Template_Source::load(null, $source->smarty, $component);
+            if ($_s->type == 'php') {
+                throw new SmartyException("Resource type {$_s->type} cannot be used with the extends resource type");
             }
-            $sources[$s->uid] = $s;
-            $uid .= realpath($s->filepath);
-            if ($_template && $_template->smarty->compile_check) {
-                $exists = $exists && $s->exists;
+            $sources[ $_s->uid ] = $_s;
+            $uid .= $_s->filepath;
+            if ($_template) {
+                $exists = $exists && $_s->exists;
             }
         }
         $source->components = $sources;
-        $source->filepath = $s->filepath;
+        $source->filepath = $_s->filepath;
         $source->uid = sha1($uid);
-        if ($_template && $_template->smarty->compile_check) {
-            $source->timestamp = $s->timestamp;
-            $source->exists = $exists;
+        $source->exists = $exists;
+        if ($_template) {
+            $source->timestamp = $_s->timestamp;
         }
-        // need the template at getContent()
-        $source->template = $_template;
     }
 
     /**
@@ -68,10 +67,11 @@
     public function populateTimestamp(Smarty_Template_Source $source)
     {
         $source->exists = true;
-        foreach ($source->components as $s) {
-            $source->exists = $source->exists && $s->exists;
+        /* @var \Smarty_Template_Source $_s */
+        foreach ($source->components as $_s) {
+            $source->exists = $source->exists && $_s->exists;
         }
-        $source->timestamp = $s->timestamp;
+        $source->timestamp = $source->exists ? $_s->getTimeStamp() : false;
     }
 
     /**
@@ -91,9 +91,10 @@
         $_components = array_reverse($source->components);
 
         $_content = '';
-        foreach ($_components as $_component) {
+        /* @var \Smarty_Template_Source $_s */
+        foreach ($_components as $_s) {
             // read content
-            $_content .= $_component->content;
+            $_content .= $_s->getContent();
         }
         return $_content;
     }
@@ -108,5 +109,16 @@
     public function getBasename(Smarty_Template_Source $source)
     {
         return str_replace(':', '.', basename($source->filepath));
+    }
+
+    /*
+      * Disable timestamp checks for extends resource.
+      * The individual source components will be checked.
+      *
+      * @return bool
+      */
+    public function checkTimestamps()
+    {
+        return false;
     }
 }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_assignglobal.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_assignglobal.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_assignglobal.php	(revision )
@@ -0,0 +1,43 @@
+<?php
+
+/**
+ * Smarty Method AssignGlobal
+ *
+ * Smarty::assignGlobal() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_AssignGlobal
+{
+    /**
+     * Valid for all objects
+     *
+     * @var int
+     */
+    public $objMap = 7;
+
+     /**
+     * assigns a global Smarty variable
+     *
+     * @param \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty $data
+     * @param  string  $varName the global variable name
+     * @param  mixed   $value   the value to assign
+     * @param  boolean $nocache if true any output of this variable will be not cached
+     *
+     * @return \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty
+     */
+    public function assignGlobal(Smarty_Internal_Data $data, $varName, $value = null, $nocache = false)
+    {
+        if ($varName != '') {
+            Smarty::$global_tpl_vars[$varName] = new Smarty_Variable($value, $nocache);
+            $ptr = $data;
+            while ($ptr->_objType == 2) {
+                $ptr->tpl_vars[$varName] = clone Smarty::$global_tpl_vars[$varName];
+                $ptr = $ptr->parent;
+            }
+        }
+        return $data;
+    }
+}
\ No newline at end of file
